% Maiztasun-eremuko adierazpen grafikoak
%
% 1) Adierazpen polarra
% 1.1) Urratsez-urrats
w=logspace(-2,2,400); %w 0.01 eta 100 rad/s bitarteko maiztasunen eskala logaritmikoan definitu 400 lagineko w bektorea.
s=j*w;
G5bek=1./(s.^2+0.5*s+1); % 2. ordenako G5(s) sistema (funtzio konplexua) 400 lagineko bektore bezala definitua.
plot(real(G5bek),imag(G5bek)) % G5(jw) ploteatzen: 'x' ardatzean G5(jw)-ren alde erreala, 'y' ardatzean G5(jw)-ren alde irudikaria.
xmin=-2.5;xmax=2.5;ymin=-2.5;ymax=2.5;
axis([xmin xmax ymin ymax]); % diagramaren ardatzen mugak ezartzen ditu.
axis equal % ardatzak eskala berdinean jartzen ditu.
grid % saretxoa jartzen du.
xlabel('G5(jw)-ren alde erreala')
ylabel('G5(jw)-ren alde irudikaria')
title('Diagrama polarra')
% 1.2) polar() funtzioaren bidez
fasea=angle(G5bek);
moduloa=abs(G5bek);
polar(fasea,moduloa)
title('Diagrama polarra')

% 2) Boderen diagramak
% 2.1) Urratsez-urrats
w=logspace(-2,2,400);
s=j*w;
G5bek=1./(s.^2+0.5*s+1);
semilogx(w,20*log10(abs(G5bek)))
grid
xlabel('w (rad/s)')
ylabel('|G5(jw)|dB')
title('moduluaren Bode diagrama')
semilogx(w,angle(G5bek)*180/pi)
grid
xlabel('w (rad/s)')
ylabel('arg(G5(jw)) -tan')
title('angeluaren Bode diagrama')
% 2.2) bode() funtzioaren bidez
G5=tf(1,[1 0.5 1])
bode(G5)

bode(G5,w)
[moduloa,fasea]=bode(G5)

% 3) Black-Nicholsen  diagrama
% 3.1) Urratsez-urrats
w=logspace(-2,2,400);
s=j*w;
G5bek=1./(s.^2+0.5*s+1);
plot(angle(G5bek)*180/pi,20*log10(abs(G5bek)))
grid
xlabel('arg(G5(jw)) -tan')
ylabel('|G5(jw)|dB')
title('Black-Nichols diagrama')
% 3.2) nichols() funtzioaren bidez
G5=tf(1,[1 0.5 1])
nichols(G5)

grid